################################################################################ BARRELS ####################################################################################

############################# Fix barrels generated in structures ###############################

execute as @e[tag=barrel,tag=!fixed] at @s if dimension apocalypse:apocalypse run data merge entity @s {HurtTime:0s,Health:1000.0f,Attributes:[{Name:generic.max_health,Base:1000}]}
execute as @e[tag=barrel,tag=!fixed] at @s if dimension apocalypse:apocalypse run tag @s add fixed

############## Renders barrel visuals based on barrel type ##############

execute as @e[tag=barrel_normal,tag=!rendered] at @s run summon item_display ~ ~0.5 ~ {Tags:["barrel_render","barrel_normal_render"],item:{id:"minecraft:slime_spawn_egg",Count:1b,tag:{CustomModelData:29291}}}
execute as @e[tag=barrel_fire,tag=!rendered] at @s run summon item_display ~ ~0.5 ~ {Tags:["barrel_render","barrel_fire_render"],item:{id:"minecraft:slime_spawn_egg",Count:1b,tag:{CustomModelData:29292}}}
execute as @e[tag=barrel_toxic,tag=!rendered] at @s run summon item_display ~ ~0.5 ~ {Tags:["barrel_render","barrel_toxic_render"],item:{id:"minecraft:slime_spawn_egg",Count:1b,tag:{CustomModelData:29293}}}

############################## Barrel render sound ##########################################
execute as @e[tag=barrel,tag=!rendered] at @s run playsound minecraft:block.netherite_block.place block @a[distance=..32] ~ ~ ~ 1.5 .7

############# Rotate the barrel hitbox so it aligns with the model ##########################
execute as @e[tag=barrel,tag=!rendered] at @s run teleport @s ~ ~ ~ 0 0

############# Tags entities that have been rendered so they don't render again ##############
tag @e[tag=barrel] add rendered

########################## Deletes render when barrel is gone ###############################
execute as @e[tag=barrel_render] at @s positioned ~ ~-0.6 ~ unless entity @e[tag=barrel,distance=..0.2] run kill @s


########################################################################## BARREL INTERACTIONS ###############################################################################


execute as @e[tag=barrel_normal] at @s unless entity @s[nbt={HurtTime:0s}] run function apocalypse:barrel_normal_break
execute as @e[tag=barrel_fire] at @s unless entity @s[nbt={HurtTime:0s}] run function apocalypse:barrel_fire_break
execute as @e[tag=barrel_toxic] at @s unless entity @s[nbt={HurtTime:0s}] run function apocalypse:barrel_toxic_break

