############# CLICK DETECTION ##################

# click detection
execute as @a if score @s right_click matches 1.. run function apocalypse:click_reset
scoreboard players remove @a[scores={click_timer=1..}] click_timer 1

#click hold detection
execute as @a[scores={click_timer=0}] run scoreboard players set @s click_hold 0
execute as @a[scores={click_timer=1..}] run scoreboard players add @s click_hold 1
execute as @a[scores={click_timer=1..}] run scoreboard players add @s click_hold2 1

#################### MILK SHIT #########################

execute as @a[tag=strong_bones] run function apocalypse:eat_can_milk_2
execute as @a[tag=strong_bones] run tag @s remove strong_bones

############################ HAZMAT ARMOR ######################################

execute as @a if entity @s[nbt={Inventory:[{Slot:100b,tag:{hazmat:1b}}]}] if entity @s[nbt={Inventory:[{Slot:101b,tag:{hazmat:1b}}]}] if entity @s[nbt={Inventory:[{Slot:102b,tag:{hazmat:1b}}]}] if entity @s[nbt={Inventory:[{Slot:103b,tag:{hazmat:1b}}]}] run effect clear @s poison

###################### OVERENCHANTING ##########################################

execute as @e[type=item,nbt={Item:{tag:{overenchanting:1b}}}] run tag @s add overenchanting
scoreboard players add @e[type=item,tag=overenchanting] age 1
execute as @e[type=item,tag=overenchanting,scores={age=40..}] at @s if entity @e[distance=..1,type=item,tag=!overenchanting,nbt={Item:{tag:{Enchantments:[{}]}}}] run function apocalypse:overenchanting


#########################################################
####################### SPELLS ##########################
#########################################################

########### Cooldowns

execute as @a[scores={apoc_fire_cd=1..}] run scoreboard players remove @s apoc_fire_cd 1
execute as @a[scores={apoc_water_cd=1..}] run scoreboard players remove @s apoc_water_cd 1
execute as @a[scores={apoc_life_cd=1..}] run scoreboard players remove @s apoc_life_cd 1

execute as @a unless entity @s[scores={apoc_fire_cd=0..}] run scoreboard players set @s apoc_fire_cd 0
execute as @a unless entity @s[scores={apoc_water_cd=0..}] run scoreboard players set @s apoc_water_cd 0
execute as @a unless entity @s[scores={apoc_life_cd=0..}] run scoreboard players set @s apoc_life_cd 0

###################### FIREBALL ##################

#fireball casting
execute as @a[scores={click_timer=4},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{fireball:1b}},Inventory:[{id:"minecraft:fire_charge"}]}] at @s run function apocalypse:spell_fireball
execute as @a[scores={click_timer=4},nbt={Inventory:[{id:"minecraft:fire_charge"},{id:"minecraft:carrot_on_a_stick",Slot:-106b,tag:{fireball:1b}}]}] at @s unless entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{spell:1b}}}] run function apocalypse:spell_fireball

# fireball spell raycasting
execute as @e[tag=fireball] at @s run data modify entity @s power set from entity @s Pos
tag @e remove fireball

################# IMMOLATE #############################

## Charging data ##

# charge level 1
#action bar
execute as @a[scores={click_hold=5..29,apoc_fire_cd=0},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{fireball2:1b}},Inventory:[{id:"minecraft:fire_charge"}]}] at @s run title @s actionbar [{"text":"⬛⬛⬛","color":"gold"},{"text":"   ⬛⬛⬛   ⬛⬛⬛","color":"dark_gray","bold":true,"italic":false}]
execute as @a[scores={click_hold=5..29,apoc_fire_cd=0},nbt={Inventory:[{id:"minecraft:fire_charge"},{id:"minecraft:carrot_on_a_stick",Slot:-106b,tag:{fireball2:1b}}]}] at @s unless entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{spell:1b}}}] run title @s actionbar [{"text":"⬛⬛⬛","color":"gold"},{"text":"   ⬛⬛⬛   ⬛⬛⬛","color":"dark_gray","bold":true,"italic":false}]

#sound
execute as @a[scores={click_hold=5,apoc_fire_cd=0},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{fireball2:1b}},Inventory:[{id:"minecraft:fire_charge"}]}] at @s run playsound minecraft:entity.experience_orb.pickup player @s ~ ~ ~ 1 .7
execute as @a[scores={click_hold=5,apoc_fire_cd=0},nbt={Inventory:[{id:"minecraft:fire_charge"},{id:"minecraft:carrot_on_a_stick",Slot:-106b,tag:{fireball2:1b}}]}] at @s unless entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{spell:1b}}}] run playsound minecraft:entity.experience_orb.pickup player @s ~ ~ ~ 1 .7

#particles
execute as @a[scores={click_hold=5..29,apoc_fire_cd=0},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{fireball2:1b}},Inventory:[{id:"minecraft:fire_charge"}]}] at @s run particle minecraft:small_flame ~ ~1 ~ 0.3 0.3 0.3 0.01 3 normal
execute as @a[scores={click_hold=5..29,apoc_fire_cd=0},nbt={Inventory:[{id:"minecraft:fire_charge"},{id:"minecraft:carrot_on_a_stick",Slot:-106b,tag:{fireball2:1b}}]}] at @s unless entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{spell:1b}}}] run particle minecraft:small_flame ~ ~1 ~ 0.3 0.3 0.3 0.01 3 normal

# charge level 2

execute as @a[scores={click_hold=30..59,apoc_fire_cd=0},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{fireball2:1b}},Inventory:[{id:"minecraft:fire_charge"}]}] at @s run title @s actionbar [{"text":"⬛⬛⬛   ⬛⬛⬛","color":"gold"},{"text":"   ⬛⬛⬛","color":"dark_gray","bold":true,"italic":false}]
execute as @a[scores={click_hold=30..59,apoc_fire_cd=0},nbt={Inventory:[{id:"minecraft:fire_charge"},{id:"minecraft:carrot_on_a_stick",Slot:-106b,tag:{fireball2:1b}}]}] at @s unless entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{spell:1b}}}] run title @s actionbar [{"text":"⬛⬛⬛   ⬛⬛⬛","color":"gold"},{"text":"⬛⬛⬛   ⬛⬛⬛","color":"dark_gray","bold":true,"italic":false}]

execute as @a[scores={click_hold=30,apoc_fire_cd=0},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{fireball2:1b}},Inventory:[{id:"minecraft:fire_charge"}]}] at @s run playsound minecraft:entity.experience_orb.pickup player @s ~ ~ ~ 1 1
execute as @a[scores={click_hold=30,apoc_fire_cd=0},nbt={Inventory:[{id:"minecraft:fire_charge"},{id:"minecraft:carrot_on_a_stick",Slot:-106b,tag:{fireball2:1b}}]}] at @s unless entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{spell:1b}}}] run playsound minecraft:entity.experience_orb.pickup player @s ~ ~ ~ 1 1

execute as @a[scores={click_hold=30..59,apoc_fire_cd=0},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{fireball2:1b}},Inventory:[{id:"minecraft:fire_charge"}]}] at @s run particle minecraft:small_flame ~ ~1 ~ 0.5 0.5 0.5 0.01 4 normal
execute as @a[scores={click_hold=30..59,apoc_fire_cd=0},nbt={Inventory:[{id:"minecraft:fire_charge"},{id:"minecraft:carrot_on_a_stick",Slot:-106b,tag:{fireball2:1b}}]}] at @s unless entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{spell:1b}}}] run particle minecraft:small_flame ~ ~1 ~ 0.5 0.5 0.5 0.01 4 normal

# charge level 3

execute as @a[scores={click_hold=60..,apoc_fire_cd=0},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{fireball2:1b}},Inventory:[{id:"minecraft:fire_charge"}]}] at @s run title @s actionbar [{"text":"⬛⬛⬛   ⬛⬛⬛   ⬛⬛⬛","color":"gold"}]
execute as @a[scores={click_hold=60..,apoc_fire_cd=0},nbt={Inventory:[{id:"minecraft:fire_charge"},{id:"minecraft:carrot_on_a_stick",Slot:-106b,tag:{fireball2:1b}}]}] at @s unless entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{spell:1b}}}] run title @s actionbar [{"text":"⬛⬛⬛   ⬛⬛⬛   ⬛⬛⬛","color":"gold"}]

execute as @a[scores={click_hold=60,apoc_fire_cd=0},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{fireball2:1b}},Inventory:[{id:"minecraft:fire_charge"}]}] at @s run playsound minecraft:entity.experience_orb.pickup player @s ~ ~ ~ 1 1.3
execute as @a[scores={click_hold=60,apoc_fire_cd=0},nbt={Inventory:[{id:"minecraft:fire_charge"},{id:"minecraft:carrot_on_a_stick",Slot:-106b,tag:{fireball2:1b}}]}] at @s unless entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{spell:1b}}}] run playsound minecraft:entity.experience_orb.pickup player @s ~ ~ ~ 1 1.3

execute as @a[scores={click_hold=60..,apoc_fire_cd=0},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{fireball2:1b}},Inventory:[{id:"minecraft:fire_charge"}]}] at @s run particle minecraft:small_flame ~ ~1 ~ 1 1 1 0.01 5 normal
execute as @a[scores={click_hold=60..,apoc_fire_cd=0},nbt={Inventory:[{id:"minecraft:fire_charge"},{id:"minecraft:carrot_on_a_stick",Slot:-106b,tag:{fireball2:1b}}]}] at @s unless entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{spell:1b}}}] run particle minecraft:small_flame ~ ~1 ~ 1 1 1 0.01 5 normal
execute as @a[scores={click_hold=60..,apoc_fire_cd=0},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{fireball2:1b}},Inventory:[{id:"minecraft:fire_charge"}]}] at @s run particle minecraft:small_flame ~ ~1 ~ 1 1 1 0.01 5 normal
execute as @a[scores={click_hold=60..,apoc_fire_cd=0},nbt={Inventory:[{id:"minecraft:fire_charge"},{id:"minecraft:carrot_on_a_stick",Slot:-106b,tag:{fireball2:1b}}]}] at @s unless entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{spell:1b}}}] run particle minecraft:smoke ~ ~1 ~ 1 1 1 0.01 5 normal

#charging particles
execute as @a[scores={click_hold=1..60,apoc_fire_cd=0},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{fireball2:1b}},Inventory:[{id:"minecraft:fire_charge"}]}] at @s run particle minecraft:enchant ~ ~1 ~ 0 0 0 1 10
execute as @a[scores={click_hold=1..30,apoc_fire_cd=0},nbt={Inventory:[{id:"minecraft:fire_charge"},{id:"minecraft:carrot_on_a_stick",Slot:-106b,tag:{fireball2:1b}}]}] at @s unless entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{spell:1b}}}] run particle minecraft:enchant ~ ~1 ~ 0 0 0 1 10

# cooldown message
execute as @a[scores={click_hold=0,click_hold2=1..,apoc_fire_cd=1..},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{fireball2:1b}},Inventory:[{id:"minecraft:fire_charge"}]}] at @s run function apocalypse:spell_on_cooldown
execute as @a[scores={click_hold=0,click_hold2=1..,apoc_fire_cd=1..},nbt={Inventory:[{id:"minecraft:fire_charge"},{id:"minecraft:carrot_on_a_stick",Slot:-106b,tag:{fireball2:1b}}]}] at @s unless entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{spell:1b}}}] run function apocalypse:spell_on_cooldown

#fireball 2 casting
execute as @a[scores={click_hold=0,click_hold2=1..,apoc_fire_cd=0},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{fireball2:1b}},Inventory:[{id:"minecraft:fire_charge"}]}] at @s run function apocalypse:spell_fireball2
execute as @a[scores={click_hold=0,click_hold2=1..,apoc_fire_cd=0},nbt={Inventory:[{id:"minecraft:fire_charge"},{id:"minecraft:carrot_on_a_stick",Slot:-106b,tag:{fireball2:1b}}]}] at @s unless entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{spell:1b}}}] run function apocalypse:spell_fireball2

# cooldown particle system
execute as @a[scores={apoc_fire_cd=1..}] at @s run particle minecraft:smoke ~ ~0.5 ~ 0.2 0.2 0.2 0.01 5
execute as @a[scores={apoc_fire_cd=1}] at @s run playsound minecraft:block.enchantment_table.use player @a ~ ~ ~ 1 2

#Ingredient shortage notification
execute as @a[scores={click_hold=0,click_hold2=1..},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{fireball2:1b}}}] unless entity @s[nbt={Inventory:[{id:"minecraft:fire_charge"}]}] at @s run function apocalypse:spell_cost_warning
execute as @a[scores={click_hold=0,click_hold2=1..},nbt={Inventory:[{id:"minecraft:carrot_on_a_stick",Slot:-106b,tag:{fireball2:1b}}]}] unless entity @s[nbt={Inventory:[{id:"minecraft:fire_charge"}]}] at @s unless entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{spell:1b}}}] run function apocalypse:spell_cost_warning

################# SLIPSTREAM ####################

# cooldown message
execute as @a[scores={click_hold=0,click_hold2=1..,apoc_water_cd=1..},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{slipstream:1b}},Inventory:[{id:"minecraft:prismarine_crystals"}]}] at @s run function apocalypse:spell_on_cooldown
execute as @a[scores={click_hold=0,click_hold2=1..,apoc_water_cd=1..},nbt={Inventory:[{id:"minecraft:prismarine_crystals"},{id:"minecraft:carrot_on_a_stick",Slot:-106b,tag:{slipstream:1b}}]}] at @s unless entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{spell:1b}}}] run function apocalypse:spell_on_cooldown

# execute slipstream spell
execute as @a[scores={click_hold=0,click_hold2=1..,apoc_water_cd=0},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{slipstream:1b}},Inventory:[{id:"minecraft:prismarine_crystals"}]}] at @s run function apocalypse:spell_slipstream
execute as @a[scores={click_hold=0,click_hold2=1..,apoc_water_cd=0},nbt={Inventory:[{id:"minecraft:prismarine_crystals"},{id:"minecraft:carrot_on_a_stick",Slot:-106b,tag:{slipstream:1b}}]}] at @s unless entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{spell:1b}}}] run function apocalypse:spell_slipstream

# cooldown particle system
execute as @a[scores={apoc_water_cd=1..}] at @s run particle minecraft:bubble_pop ~ ~1 ~ 0.2 0.2 0.2 0.01 5
execute as @a[scores={apoc_water_cd=1}] at @s run playsound minecraft:block.enchantment_table.use player @a ~ ~ ~ 1 2

#Ingredient shortage notification
execute as @a[scores={click_hold=0,click_hold2=1..},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{slipstream:1b}}}] unless entity @s[nbt={Inventory:[{id:"minecraft:prismarine_crystals"}]}] at @s run function apocalypse:spell_cost_warning
execute as @a[scores={click_hold=0,click_hold2=1..},nbt={Inventory:[{id:"minecraft:carrot_on_a_stick",Slot:-106b,tag:{slipstream:1b}}]}] unless entity @s[nbt={Inventory:[{id:"minecraft:prismarine_crystals"}]}] at @s unless entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{spell:1b}}}] run function apocalypse:spell_cost_warning

################# SLIPSTREAM 2 ####################

# cooldown message
execute as @a[scores={click_hold=0,click_hold2=1..,apoc_water_cd=1..},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{slipstream2:1b}},Inventory:[{id:"minecraft:prismarine_crystals"}]}] at @s run function apocalypse:spell_on_cooldown
execute as @a[scores={click_hold=0,click_hold2=1..,apoc_water_cd=1..},nbt={Inventory:[{id:"minecraft:prismarine_crystals"},{id:"minecraft:carrot_on_a_stick",Slot:-106b,tag:{slipstream2:1b}}]}] at @s unless entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{spell:1b}}}] run function apocalypse:spell_on_cooldown

# execute slipstream2 spell
execute as @a[scores={click_hold=0,click_hold2=1..,apoc_water_cd=0},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{slipstream2:1b}},Inventory:[{id:"minecraft:prismarine_crystals"}]}] at @s run function apocalypse:spell_slipstream2
execute as @a[scores={click_hold=0,click_hold2=1..,apoc_water_cd=0},nbt={Inventory:[{id:"minecraft:prismarine_crystals"},{id:"minecraft:carrot_on_a_stick",Slot:-106b,tag:{slipstream2:1b}}]}] at @s unless entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{spell:1b}}}] run function apocalypse:spell_slipstream2

# cooldown particle system
execute as @a[scores={apoc_water_cd=1..}] at @s run particle minecraft:bubble_pop ~ ~1 ~ 0.2 0.2 0.2 0.01 5
execute as @a[scores={apoc_water_cd=1}] at @s run playsound minecraft:block.enchantment_table.use player @a ~ ~ ~ 1 2

#Ingredient shortage notification
execute as @a[scores={click_hold=0,click_hold2=1..},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{slipstream2:1b}}}] unless entity @s[nbt={Inventory:[{id:"minecraft:prismarine_crystals"}]}] at @s run function apocalypse:spell_cost_warning
execute as @a[scores={click_hold=0,click_hold2=1..},nbt={Inventory:[{id:"minecraft:carrot_on_a_stick",Slot:-106b,tag:{slipstream2:1b}}]}] unless entity @s[nbt={Inventory:[{id:"minecraft:prismarine_crystals"}]}] at @s unless entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{spell:1b}}}] run function apocalypse:spell_cost_warning

## Charging effects/sounds ##
execute as @a[scores={click_hold=30,apoc_water_cd=0},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{slipstream2:1b}},Inventory:[{id:"minecraft:prismarine_crystals"}]}] at @s run playsound minecraft:block.note_block.chime player @s ~ ~ ~ 0.5 1
execute as @a[scores={click_hold=30,apoc_water_cd=0},nbt={Inventory:[{id:"minecraft:prismarine_crystals"},{id:"minecraft:carrot_on_a_stick",Slot:-106b,tag:{slipstream2:1b}}]}] at @s unless entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{spell:1b}}}] run playsound minecraft:block.note_block.chime player @s ~ ~ ~ 0.5 1
execute as @a[scores={click_hold=30,apoc_water_cd=0},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{slipstream2:1b}},Inventory:[{id:"minecraft:prismarine_crystals"}]}] at @s run particle minecraft:poof ~ ~1 ~ 0 0 0 0.5 100
execute as @a[scores={click_hold=30,apoc_water_cd=0},nbt={Inventory:[{id:"minecraft:prismarine_crystals"},{id:"minecraft:carrot_on_a_stick",Slot:-106b,tag:{slipstream2:1b}}]}] at @s unless entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{spell:1b}}}] run particle minecraft:poof ~ ~1 ~ 1 1 1 0.5 100


execute as @a[scores={click_hold=1..30,apoc_water_cd=0},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{slipstream2:1b}},Inventory:[{id:"minecraft:prismarine_crystals"}]}] at @s run particle minecraft:enchant ~ ~1 ~ 0 0 0 1 10
execute as @a[scores={click_hold=1..30,apoc_water_cd=0},nbt={Inventory:[{id:"minecraft:prismarine_crystals"},{id:"minecraft:carrot_on_a_stick",Slot:-106b,tag:{slipstream2:1b}}]}] at @s unless entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{spell:1b}}}] run particle minecraft:enchant ~ ~1 ~ 0 0 0 1 10

################# FORTIFY #######################

# cooldown message
execute as @a[scores={click_hold=0,click_hold2=1..,apoc_life_cd=1..},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{fortify:1b}},Inventory:[{id:"minecraft:golden_carrot"}]}] at @s run function apocalypse:spell_on_cooldown
execute as @a[scores={click_hold=0,click_hold2=1..,apoc_life_cd=1..},nbt={Inventory:[{id:"minecraft:golden_carrot"},{id:"minecraft:carrot_on_a_stick",Slot:-106b,tag:{fortify:1b}}]}] at @s unless entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{spell:1b}}}] run function apocalypse:spell_on_cooldown

# execute fortify spell
execute as @a[scores={click_hold=0,click_hold2=1..,apoc_life_cd=0},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{fortify:1b}},Inventory:[{id:"minecraft:golden_carrot"}]}] at @s run function apocalypse:spell_fortify
execute as @a[scores={click_hold=0,click_hold2=1..,apoc_life_cd=0},nbt={Inventory:[{id:"minecraft:golden_carrot"},{id:"minecraft:carrot_on_a_stick",Slot:-106b,tag:{fortify:1b}}]}] at @s unless entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{spell:1b}}}] run function apocalypse:spell_fortify

# cooldown particle system
execute as @a[scores={apoc_life_cd=1..}] at @s run particle minecraft:cherry_leaves ~ ~1 ~ 0.2 0.2 0.2 1 2
execute as @a[scores={apoc_life_cd=1}] at @s run playsound minecraft:block.enchantment_table.use player @a ~ ~ ~ 1 2

#Ingredient shortage notification
execute as @a[scores={click_hold=0,click_hold2=1..},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{fortify:1b}}}] unless entity @s[nbt={Inventory:[{id:"minecraft:golden_carrot"}]}] at @s run function apocalypse:spell_cost_warning
execute as @a[scores={click_hold=0,click_hold2=1..},nbt={Inventory:[{id:"minecraft:carrot_on_a_stick",Slot:-106b,tag:{fortify:1b}}]}] unless entity @s[nbt={Inventory:[{id:"minecraft:golden_carrot"}]}] at @s unless entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{spell:1b}}}] run function apocalypse:spell_cost_warning

################ FORTIFY2 #########################
# cooldown message
execute as @a[scores={click_hold=0,click_hold2=1..,apoc_life_cd=1..},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{fortify2:1b}},Inventory:[{id:"minecraft:golden_carrot"}]}] at @s run function apocalypse:spell_on_cooldown
execute as @a[scores={click_hold=0,click_hold2=1..,apoc_life_cd=1..},nbt={Inventory:[{id:"minecraft:golden_carrot"},{id:"minecraft:carrot_on_a_stick",Slot:-106b,tag:{fortify2:1b}}]}] at @s unless entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{spell:1b}}}] run function apocalypse:spell_on_cooldown

# execute fortify2 spell
execute as @a[scores={click_hold=0,click_hold2=1..,apoc_life_cd=0},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{fortify2:1b}},Inventory:[{id:"minecraft:golden_carrot"}]}] at @s run function apocalypse:spell_fortify2
execute as @a[scores={click_hold=0,click_hold2=1..,apoc_life_cd=0},nbt={Inventory:[{id:"minecraft:golden_carrot"},{id:"minecraft:carrot_on_a_stick",Slot:-106b,tag:{fortify2:1b}}]}] at @s unless entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{spell:1b}}}] run function apocalypse:spell_fortify2

#Ingredient shortage notification
execute as @a[scores={click_hold=0,click_hold2=1..},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{fortify2:1b}}}] unless entity @s[nbt={Inventory:[{id:"minecraft:golden_carrot"}]}] at @s run function apocalypse:spell_cost_warning
execute as @a[scores={click_hold=0,click_hold2=1..},nbt={Inventory:[{id:"minecraft:carrot_on_a_stick",Slot:-106b,tag:{fortify2:1b}}]}] unless entity @s[nbt={Inventory:[{id:"minecraft:golden_carrot"}]}] at @s unless entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{spell:1b}}}] run function apocalypse:spell_cost_warning

# Charge notification
execute as @a[scores={click_hold=30,apoc_life_cd=0},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{fortify2:1b}},Inventory:[{id:"minecraft:golden_carrot"}]}] at @s run playsound minecraft:block.note_block.chime player @s ~ ~ ~ 0.5 1
execute as @a[scores={click_hold=30,apoc_life_cd=0},nbt={Inventory:[{id:"minecraft:golden_carrot"},{id:"minecraft:carrot_on_a_stick",Slot:-106b,tag:{fortify2:1b}}]}] at @s unless entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{spell:1b}}}] run playsound minecraft:block.note_block.chime player @s ~ ~ ~ 0.5 1
execute as @a[scores={click_hold=30,apoc_life_cd=0},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{fortify2:1b}},Inventory:[{id:"minecraft:golden_carrot"}]}] at @s run particle minecraft:poof ~ ~1 ~ 0 0 0 0.5 100
execute as @a[scores={click_hold=30,apoc_life_cd=0},nbt={Inventory:[{id:"minecraft:golden_carrot"},{id:"minecraft:carrot_on_a_stick",Slot:-106b,tag:{fortify2:1b}}]}] at @s unless entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{spell:1b}}}] run particle minecraft:poof ~ ~1 ~ 1 1 1 0.5 100

execute as @a[scores={click_hold=1..30,apoc_life_cd=0},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{fortify2:1b}},Inventory:[{id:"minecraft:golden_carrot"}]}] at @s run particle minecraft:enchant ~ ~1 ~ 0 0 0 1 10
execute as @a[scores={click_hold=1..30,apoc_life_cd=0},nbt={Inventory:[{id:"minecraft:golden_carrot"},{id:"minecraft:carrot_on_a_stick",Slot:-106b,tag:{fortify2:1b}}]}] at @s unless entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{spell:1b}}}] run particle minecraft:enchant ~ ~1 ~ 0 0 0 1 10

### charge duration detection clearing ###

execute as @a[scores={click_timer=0}] run scoreboard players set @s click_hold2 0

######################## TOTEMS ###########################


###Magic totems

execute as @a if entity @s[nbt={SelectedItem:{id:"minecraft:totem_of_undying",Count:1b}}] run function apocalypse:totem_main
execute as @a if entity @s[nbt={Inventory:[{id:"minecraft:totem_of_undying",Slot:-106b}]}] run function apocalypse:totem_offhand



