###### Visual Effects #######

execute at @e[tag=blazing] run particle minecraft:lava ~ ~ ~ 0 0 0 0.5 1 normal
execute at @e[tag=irradiated] run particle minecraft:dust 0.620 1.000 0.051 1 ~ ~1 ~ 0.5 0.5 0.5 3 3 normal
execute at @e[tag=glacial] run particle snowflake ~ ~1.2 ~ .2 .5 .2 0.005 3 normal
execute at @e[tag=withering] run particle minecraft:sculk_soul ~ ~1 ~ 0.5 0.5 0.5 0.01 1 normal

execute as @e[tag=elite] at @s if entity @a[distance=..8] run effect give @s glowing 1 1

##### Blazing ############

execute as @e[tag=blazing] unless entity @s[nbt={HurtTime:0s}] at @s anchored feet run setblock ~ ~ ~ fire keep


######################################## SPAWNING ###########################################

###################### Zombie variants ###########################

##### Rolling and tagging #####
execute in apocalypse:apocalypse as @e[type=zombie,tag=!apoc_rolled] store result score @s spawn_roll run random value 1..10

# Blazing
execute in apocalypse:apocalypse as @e[type=zombie, tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:ashen_forest run summon zombie ~ ~0.5 ~ {Fire:999999999,HasVisualFire:1b,DeathLootTable:"apocalypse:blazing_zombie",Team:"blazing",Health:40f,Tags:["elite","apoc_rolled","blazing"],CustomName:'{"text":"Blazing","color":"gold"}',active_effects:[{id:"minecraft:strength",amplifier:0b,duration:-1,show_particles:0b},{id:"minecraft:fire_resistance",amplifier:0b,duration:-1,ambient:1b}],Attributes:[{Name:generic.max_health,Base:40}]}
execute in apocalypse:apocalypse as @e[type=zombie, tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:ashen_forest run tp @s ~ -600 ~
execute in apocalypse:apocalypse as @e[type=zombie, tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:ashen_basalt run summon zombie ~ ~0.5 ~ {Fire:999999999,HasVisualFire:1b,DeathLootTable:"apocalypse:blazing_zombie",Team:"blazing",Health:40f,Tags:["elite","apoc_rolled","blazing"],CustomName:'{"text":"Blazing","color":"gold"}',active_effects:[{id:"minecraft:strength",amplifier:0b,duration:-1,show_particles:0b},{id:"minecraft:fire_resistance",amplifier:0b,duration:-1,ambient:1b}],Attributes:[{Name:generic.max_health,Base:40}]}
execute in apocalypse:apocalypse as @e[type=zombie, tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:ashen_basalt run tp @s ~ -600 ~

# Irradiated
execute in apocalypse:apocalypse as @e[type=zombie, tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:toxic_swamp run summon zombie ~ ~1 ~ {DeathLootTable:"apocalypse:irradiated_zombie",Team:"irradiated",Health:40f,Tags:["elite","apoc_rolled","irradiated"],CustomName:'{"text":"Irradiated","color":"green"}',Attributes:[{Name:generic.max_health,Base:40},{Name:generic.follow_range,Base:56},{Name:generic.movement_speed,Base:0.35}]}
execute in apocalypse:apocalypse as @e[type=zombie, tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:toxic_swamp run tp @s ~ -600 ~
execute in apocalypse:apocalypse as @e[type=zombie, tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:toxic_bog run summon zombie ~ ~1 ~ {DeathLootTable:"apocalypse:irradiated_zombie",Team:"irradiated",Health:40f,Tags:["elite","apoc_rolled","irradiated"],CustomName:'{"text":"Irradiated","color":"green"}',Attributes:[{Name:generic.max_health,Base:40},{Name:generic.follow_range,Base:56},{Name:generic.movement_speed,Base:0.35}]}
execute in apocalypse:apocalypse as @e[type=zombie, tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:toxic_bog run tp @s ~ -600 ~

#Glacial
execute in apocalypse:apocalypse as @e[type=zombie, tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:volcanic_taiga run summon zombie ~ ~1 ~ {HasVisualFire:0b,DeathLootTable:"apocalypse:glacial_zombie",Team:"glacial",Health:40f,Tags:["elite","apoc_rolled","glacial"],CustomName:'{"text":"Glacial","color":"aqua"}',Attributes:[{Name:generic.max_health,Base:40},{Name:generic.knockback_resistance,Base:0.5},{Name:generic.armor,Base:6}]}
execute in apocalypse:apocalypse as @e[type=zombie, tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:volcanic_taiga run tp @s ~ -600 ~
execute in apocalypse:apocalypse as @e[type=zombie, tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:volcanic_beach run summon zombie ~ ~1 ~ {HasVisualFire:0b,DeathLootTable:"apocalypse:glacial_zombie",Team:"glacial",Health:40f,Tags:["elite","apoc_rolled","glacial"],CustomName:'{"text":"Glacial","color":"aqua"}',Attributes:[{Name:generic.max_health,Base:40},{Name:generic.knockback_resistance,Base:0.5},{Name:generic.armor,Base:6}]}
execute in apocalypse:apocalypse as @e[type=zombie, tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:volcanic_beach run tp @s ~ -600 ~

#Withering
execute in apocalypse:apocalypse as @e[type=zombie, tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:wasteland run summon zombie ~ ~1 ~ {HasVisualFire:0b,DeathLootTable:"apocalypse:withering_zombie",Team:"withering",Health:40f,Tags:["elite","apoc_rolled","withering"],CustomName:'{"text":"Withering","color":"black"}',Attributes:[{Name:generic.max_health,Base:40},{Name:generic.armor,Base:6},{Name:generic.attack_knockback,Base:2}]}
execute in apocalypse:apocalypse as @e[type=zombie, tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:wasteland run tp @s ~ -600 ~
execute in apocalypse:apocalypse as @e[type=zombie, tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:wasted_desert run summon zombie ~ ~1 ~ {HasVisualFire:0b,DeathLootTable:"apocalypse:withering_zombie",Team:"withering",Health:40f,Tags:["elite","apoc_rolled","withering"],CustomName:'{"text":"Withering","color":"black"}',Attributes:[{Name:generic.max_health,Base:40},{Name:generic.armor,Base:6},{Name:generic.attack_knockback,Base:2}]}
execute in apocalypse:apocalypse as @e[type=zombie, tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:wasted_desert run tp @s ~ -600 ~

## cull elite spawn entities ##
execute in apocalypse:apocalypse as @e[type=zombie,tag=!apoc_rolled,scores={spawn_roll=6..10}] if entity @e[distance=..0.5,tag=elite] run kill @s
execute in apocalypse:apocalypse as @e[type=zombie,tag=!apoc_rolled] run tag @s add apoc_rolled

############## Husks ###############################

##### Rolling and tagging #####
execute in apocalypse:apocalypse as @e[type=husk,tag=!apoc_rolled] store result score @s spawn_roll run random value 1..10

#Withering
execute in apocalypse:apocalypse as @e[type=husk,tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:wasteland run summon husk ~ ~1 ~ {HasVisualFire:0b,DeathLootTable:"apocalypse:withering_zombie",Team:"withering",Health:40f,Tags:["elite","apoc_rolled","withering"],CustomName:'{"text":"Withering","color":"black"}',Attributes:[{Name:generic.max_health,Base:40},{Name:generic.armor,Base:6},{Name:generic.attack_knockback,Base:2}]}
execute in apocalypse:apocalypse as @e[type=husk,tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:wasteland run tp @s ~ -600 ~
execute in apocalypse:apocalypse as @e[type=husk,tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:wasted_desert run summon husk ~ ~1 ~ {HasVisualFire:0b,DeathLootTable:"apocalypse:withering_zombie",Team:"withering",Health:40f,Tags:["elite","apoc_rolled","withering"],CustomName:'{"text":"Withering","color":"black"}',Attributes:[{Name:generic.max_health,Base:40},{Name:generic.armor,Base:6},{Name:generic.attack_knockback,Base:2}]}
execute in apocalypse:apocalypse as @e[type=husk,tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:wasted_desert run tp @s ~ -600 ~

## cull elite spawn entities ##
execute in apocalypse:apocalypse as @e[type=husk,tag=!apoc_rolled,scores={spawn_roll=6..10}] if entity @e[distance=..0.5,tag=elite] run kill @s
execute in apocalypse:apocalypse as @e[type=husk,tag=!apoc_rolled] run tag @s add apoc_rolled


#################### Skeleton Variants ###########################

##### Rolling and tagging #####
execute in apocalypse:apocalypse as @e[type=skeleton,tag=!apoc_rolled] store result score @s spawn_roll run random value 1..10

# Blazing
execute in apocalypse:apocalypse as @e[type=skeleton, tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:ashen_forest run summon skeleton ~ ~1 ~ {Fire:999999999,HasVisualFire:1b,DeathLootTable:"apocalypse:blazing_skeleton",Team:"blazing",Health:40f,Tags:["elite","apoc_rolled","blazing"],CustomName:'{"text":"Blazing","color":"gold"}',HandItems:[{id:"minecraft:bow",Count:1b},{id:"minecraft:tipped_arrow",Count:8b,tag:{Potion:"minecraft:harming"}}],HandDropChances:[0.085F,0.200F],active_effects:[{id:"minecraft:strength",amplifier:0b,duration:-1,show_particles:0b},{id:"minecraft:fire_resistance",amplifier:0b,duration:-1,ambient:1b}],Attributes:[{Name:generic.max_health,Base:40}]}
execute in apocalypse:apocalypse as @e[type=skeleton, tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:ashen_forest run tp @s ~ -600 ~
execute in apocalypse:apocalypse as @e[type=skeleton, tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:ashen_basalt run summon skeleton ~ ~1 ~ {Fire:999999999,HasVisualFire:1b,DeathLootTable:"apocalypse:blazing_skeleton",Team:"blazing",Health:40f,Tags:["elite","apoc_rolled","blazing"],CustomName:'{"text":"Blazing","color":"gold"}',HandItems:[{id:"minecraft:bow",Count:1b},{id:"minecraft:tipped_arrow",Count:8b,tag:{Potion:"minecraft:harming"}}],HandDropChances:[0.085F,0.200F],active_effects:[{id:"minecraft:strength",amplifier:0b,duration:-1,show_particles:0b},{id:"minecraft:fire_resistance",amplifier:0b,duration:-1,ambient:1b}],Attributes:[{Name:generic.max_health,Base:40}]}
execute in apocalypse:apocalypse as @e[type=skeleton, tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:ashen_basalt run tp @s ~ -600 ~

# Irradiated
execute in apocalypse:apocalypse as @e[type=skeleton, tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:toxic_swamp run summon skeleton ~ ~1 ~ {DeathLootTable:"apocalypse:irradiated_skeleton",Team:"irradiated",Health:40f,Tags:["elite","apoc_rolled","irradiated"],CustomName:'{"text":"Irradiated","color":"green"}',HandItems:[{id:"minecraft:bow",Count:1b},{}],Attributes:[{Name:generic.max_health,Base:40},{Name:generic.follow_range,Base:24},{Name:generic.movement_speed,Base:0.30}]}
execute in apocalypse:apocalypse as @e[type=skeleton, tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:toxic_swamp run tp @s ~ -600 ~
execute in apocalypse:apocalypse as @e[type=skeleton, tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:toxic_bog run summon skeleton ~ ~1 ~ {DeathLootTable:"apocalypse:irradiated_skeleton",Team:"irradiated",Health:40f,Tags:["elite","apoc_rolled","irradiated"],CustomName:'{"text":"Irradiated","color":"green"}',HandItems:[{id:"minecraft:bow",Count:1b},{}],Attributes:[{Name:generic.max_health,Base:40},{Name:generic.follow_range,Base:24},{Name:generic.movement_speed,Base:0.30}]}
execute in apocalypse:apocalypse as @e[type=skeleton, tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:toxic_bog run tp @s ~ -600 ~

#Glacial
execute in apocalypse:apocalypse as @e[type=skeleton, tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:volcanic_taiga run summon skeleton ~ ~1 ~ {DeathLootTable:"apocalypse:glacial_skeleton",Team:"glacial",Health:40f,Tags:["elite","apoc_rolled","glacial"],CustomName:'{"text":"Glacial","color":"aqua"}',HandItems:[{id:"minecraft:bow",Count:1b},{}],Attributes:[{Name:generic.max_health,Base:40},{Name:generic.knockback_resistance,Base:0.5},{Name:generic.armor,Base:6}]}
execute in apocalypse:apocalypse as @e[type=skeleton, tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:volcanic_taiga run tp @s ~ -600 ~
execute in apocalypse:apocalypse as @e[type=skeleton, tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:volcanic_beach run summon skeleton ~ ~1 ~ {DeathLootTable:"apocalypse:glacial_skeleton",Team:"glacial",Health:40f,Tags:["elite","apoc_rolled","glacial"],CustomName:'{"text":"Glacial","color":"aqua"}',HandItems:[{id:"minecraft:bow",Count:1b},{}],Attributes:[{Name:generic.max_health,Base:40},{Name:generic.knockback_resistance,Base:0.5},{Name:generic.armor,Base:6}]}
execute in apocalypse:apocalypse as @e[type=skeleton, tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:volcanic_beach run tp @s ~ -600 ~

## cull elite spawn entities ##
execute in apocalypse:apocalypse as @e[type=skeleton, tag=!apoc_rolled,scores={spawn_roll=6..10}] if entity @e[distance=..0.5,tag=elite] run kill @s
execute in apocalypse:apocalypse as @e[type=skeleton,tag=!apoc_rolled] run tag @s add apoc_rolled

############ Strays ###################

##### Rolling and tagging #####
execute in apocalypse:apocalypse as @e[type=stray,tag=!apoc_rolled] store result score @s spawn_roll run random value 1..10

#Glacial
execute in apocalypse:apocalypse as @e[type=stray, tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:volcanic_taiga run summon stray ~ ~1 ~ {HasVisualFire:0b,DeathLootTable:"apocalypse:glacial_stray",Team:"glacial",Health:40f,Tags:["elite","glacial"],CustomName:'{"text":"Glacial","color":"aqua"}',HandItems:[{id:"minecraft:bow",Count:1b},{}],Attributes:[{Name:generic.max_health,Base:40},{Name:generic.knockback_resistance,Base:0.5},{Name:generic.armor,Base:6}]}
execute in apocalypse:apocalypse as @e[type=stray, tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:volcanic_taiga run tp @s ~ -600 ~
execute in apocalypse:apocalypse as @e[type=stray, tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:volcanic_beach run summon stray ~ ~1 ~ {HasVisualFire:0b,DeathLootTable:"apocalypse:glacial_stray",Team:"glacial",Health:40f,Tags:["elite","glacial"],CustomName:'{"text":"Glacial","color":"aqua"}',HandItems:[{id:"minecraft:bow",Count:1b},{}],Attributes:[{Name:generic.max_health,Base:40},{Name:generic.knockback_resistance,Base:0.5},{Name:generic.armor,Base:6}]}
execute in apocalypse:apocalypse as @e[type=stray, tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:volcanic_beach run tp @s ~ -600 ~

## cull elite spawn entities ##
execute in apocalypse:apocalypse as @e[type=stray,tag=!apoc_rolled,scores={spawn_roll=6..10}] if entity @e[distance=..0.5,tag=elite] run kill @s
execute in apocalypse:apocalypse as @e[type=stray,tag=!apoc_rolled] run tag @s add apoc_rolled

############ Wither Skeletons ########################

##### Rolling and tagging #####
execute in apocalypse:apocalypse as @e[type=wither_skeleton,tag=!apoc_rolled] store result score @s spawn_roll run random value 1..10

#Blazing
execute in apocalypse:apocalypse as @e[type=wither_skeleton,tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:ashen_forest run summon wither_skeleton ~ ~1 ~ {DeathLootTable:"apocalypse:blazing_wither_skeleton",Team:"blazing",Health:40f,Tags:["elite","blazing"],CustomName:'{"text":"Blazing","color":"gold"}',HandItems:[{id:"minecraft:iron_sword",Count:1b},{}],HandDropChances:[0.085F,0.500F],active_effects:[{id:"minecraft:strength",amplifier:0b,duration:-1,show_particles:0b},{id:"minecraft:fire_resistance",amplifier:0b,duration:-1,ambient:1b}],Attributes:[{Name:generic.max_health,Base:40}]}
execute in apocalypse:apocalypse as @e[type=wither_skeleton,tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:ashen_forest run tp @s ~ -600 ~
execute in apocalypse:apocalypse as @e[type=wither_skeleton,tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:ashen_basalt run summon wither_skeleton ~ ~1 ~ {DeathLootTable:"apocalypse:blazing_wither_skeleton",Team:"blazing",Health:40f,Tags:["elite","blazing"],CustomName:'{"text":"Blazing","color":"gold"}',HandItems:[{id:"minecraft:iron_sword",Count:1b},{}],HandDropChances:[0.085F,0.500F],active_effects:[{id:"minecraft:strength",amplifier:0b,duration:-1,show_particles:0b},{id:"minecraft:fire_resistance",amplifier:0b,duration:-1,ambient:1b}],Attributes:[{Name:generic.max_health,Base:40}]}
execute in apocalypse:apocalypse as @e[type=wither_skeleton,tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:ashen_basalt run tp @s ~ -600 ~

## cull elite spawn entities ##
execute in apocalypse:apocalypse as @e[type=wither_skeleton,tag=!apoc_rolled,scores={spawn_roll=6..10}] if entity @e[distance=..0.5,tag=elite] run kill @s
execute in apocalypse:apocalypse as @e[type=wither_skeleton,tag=!apoc_rolled] run tag @s add apoc_rolled

###################### ENDERMEN ###########################

##### Rolling and tagging #####
execute in apocalypse:apocalypse as @e[type=enderman,tag=!apoc_rolled] store result score @s spawn_roll run random value 1..10

# Blazing
execute in apocalypse:apocalypse as @e[type=enderman,tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:ashen_forest run summon enderman ~ ~1 ~ {Fire:999999999,HasVisualFire:1b,DeathLootTable:"apocalypse:blazing_enderman",Team:"blazing",Health:80f,Tags:["elite","blazing"],CustomName:'{"text":"Blazing","color":"gold"}',active_effects:[{id:"minecraft:strength",amplifier:0b,duration:-1,show_particles:0b},{id:"minecraft:fire_resistance",amplifier:0b,duration:-1,ambient:1b}],Attributes:[{Name:generic.max_health,Base:80}]}
execute in apocalypse:apocalypse as @e[type=enderman,tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:ashen_forest run tp @s ~ -600 ~
execute in apocalypse:apocalypse as @e[type=enderman,tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:ashen_basalt run summon enderman ~ ~1 ~ {Fire:999999999,HasVisualFire:1b,DeathLootTable:"apocalypse:blazing_enderman",Team:"blazing",Health:80f,Tags:["elite","blazing"],CustomName:'{"text":"Blazing","color":"gold"}',active_effects:[{id:"minecraft:strength",amplifier:0b,duration:-1,show_particles:0b},{id:"minecraft:fire_resistance",amplifier:0b,duration:-1,ambient:1b}],Attributes:[{Name:generic.max_health,Base:80}]}
execute in apocalypse:apocalypse as @e[type=enderman,tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:ashen_basalt run tp @s ~ -600 ~

# Irradiated
execute in apocalypse:apocalypse as @e[type=enderman,tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:toxic_swamp run summon enderman ~ ~1 ~ {DeathLootTable:"apocalypse:irradiated_enderman",Team:"irradiated",Health:60f,Tags:["elite","irradiated"],CustomName:'{"text":"Irradiated","color":"green"}',Attributes:[{Name:generic.max_health,Base:80},{Name:generic.movement_speed,Base:0.35}]}
execute in apocalypse:apocalypse as @e[type=enderman,tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:toxic_swamp run tp @s ~ -600 ~
execute in apocalypse:apocalypse as @e[type=enderman,tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:toxic_bog run summon enderman ~ ~1 ~ {DeathLootTable:"apocalypse:irradiated_enderman",Team:"irradiated",Health:60f,Tags:["elite","irradiated"],CustomName:'{"text":"Irradiated","color":"green"}',Attributes:[{Name:generic.max_health,Base:80},{Name:generic.movement_speed,Base:0.35}]}
execute in apocalypse:apocalypse as @e[type=enderman,tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:toxic_bog run tp @s ~ -600 ~

#Glacial
execute in apocalypse:apocalypse as @e[type=enderman,tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:volcanic_taiga run summon enderman ~ ~1 ~ {HasVisualFire:0b,DeathLootTable:"apocalypse:glacial_enderman",Team:"glacial",Health:80f,Tags:["elite","glacial"],CustomName:'{"text":"Glacial","color":"aqua"}',HandItems:[{id:"minecraft:bow",Count:1b},{}],Attributes:[{Name:generic.max_health,Base:80},{Name:generic.knockback_resistance,Base:0.5},{Name:generic.armor,Base:6}]}
execute in apocalypse:apocalypse as @e[type=enderman,tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:volcanic_taiga run tp @s ~ -600 ~
execute in apocalypse:apocalypse as @e[type=enderman,tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:volcanic_beach run summon enderman ~ ~1 ~ {HasVisualFire:0b,DeathLootTable:"apocalypse:glacial_stray",Team:"glacial",Health:80f,Tags:["elite","glacial"],CustomName:'{"text":"Glacial","color":"aqua"}',HandItems:[{id:"minecraft:bow",Count:1b},{}],Attributes:[{Name:generic.max_health,Base:80},{Name:generic.knockback_resistance,Base:0.5},{Name:generic.armor,Base:6}]}
execute in apocalypse:apocalypse as @e[type=enderman,tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:volcanic_beach run tp @s ~ -600 ~

#Withering
execute in apocalypse:apocalypse as @e[type=enderman,tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:wasteland run summon enderman ~ ~1 ~ {HasVisualFire:0b,DeathLootTable:"apocalypse:withering_enderman",Team:"withering",Health:80f,Tags:["elite","withering"],CustomName:'{"text":"Withering","color":"black"}',Attributes:[{Name:generic.max_health,Base:80},{Name:generic.armor,Base:6},{Name:generic.attack_knockback,Base:2}]}
execute in apocalypse:apocalypse as @e[type=enderman,tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:wasteland run tp @s ~ -600 ~
execute in apocalypse:apocalypse as @e[type=enderman,tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:wasted_desert run summon enderman ~ ~1 ~ {HasVisualFire:0b,DeathLootTable:"apocalypse:withering_enderman",Team:"withering",Health:80f,Tags:["elite","withering"],CustomName:'{"text":"Withering","color":"black"}',Attributes:[{Name:generic.max_health,Base:80},{Name:generic.armor,Base:6},{Name:generic.attack_knockback,Base:2}]}
execute in apocalypse:apocalypse as @e[type=enderman,tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:wasted_desert run tp @s ~ -600 ~

## cull elite spawn entities ##
execute in apocalypse:apocalypse as @e[type=enderman,tag=!apoc_rolled,scores={spawn_roll=6..10}] if entity @e[distance=..0.5,tag=elite] run kill @s
execute in apocalypse:apocalypse as @e[type=enderman,tag=!apoc_rolled] run tag @s add apoc_rolled

#################### CREEPERS ########################

##### Rolling and tagging #####
execute in apocalypse:apocalypse as @e[type=creeper,tag=!apoc_rolled] store result score @s spawn_roll run random value 1..10

#Blazing
execute in apocalypse:apocalypse as @e[type=creeper,tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:toxic_swamp run summon creeper ~ ~1 ~ {DeathLootTable:"apocalypse:irradiated_creeper",Team:"irradiated",Health:40f,ExplosionRadius:5b,Tags:["elite","irradiated"],CustomName:'{"text":"Irradiated","color":"green"}',Attributes:[{Name:generic.max_health,Base:40},{Name:generic.follow_range,Base:24},{Name:generic.movement_speed,Base:0.35}]}
execute in apocalypse:apocalypse as @e[type=creeper,tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:toxic_swamp run tp @s ~ -600 ~
execute in apocalypse:apocalypse as @e[type=creeper,tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:toxic_bog run summon creeper ~ ~1 ~ {DeathLootTable:"apocalypse:irradiated_creeper",Team:"irradiated",Health:40f,ExplosionRadius:5b,Tags:["elite","irradiated"],CustomName:'{"text":"Irradiated","color":"green"}',Attributes:[{Name:generic.max_health,Base:40},{Name:generic.follow_range,Base:24},{Name:generic.movement_speed,Base:0.35}]}
execute in apocalypse:apocalypse as @e[type=creeper,tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:toxic_bog run tp @s ~ -600 ~

## cull elite spawn entities ##
execute in apocalypse:apocalypse as @e[type=creeper,tag=!apoc_rolled,scores={spawn_roll=6..10}] if entity @e[distance=..0.5,tag=elite] run kill @s
execute in apocalypse:apocalypse as @e[type=creeper,tag=!apoc_rolled] run tag @s add apoc_rolled

#################### SPIDER ########################

##### Rolling and tagging #####
execute in apocalypse:apocalypse as @e[type=spider,tag=!apoc_rolled] store result score @s spawn_roll run random value 1..10

#withering
execute in apocalypse:apocalypse as @e[type=spider,tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:wasteland run summon spider ~ ~1 ~ {HasVisualFire:0b,DeathLootTable:"apocalypse:withering_spider",Team:"withering",Health:40f,Tags:["elite","withering"],CustomName:'{"text":"Withering","color":"black"}',Attributes:[{Name:generic.max_health,Base:40},{Name:generic.armor,Base:6},{Name:generic.attack_knockback,Base:2}]}
execute in apocalypse:apocalypse as @e[type=spider,tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:wasteland run tp @s ~ -600 ~
execute in apocalypse:apocalypse as @e[type=spider,tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:wasted_desert run summon spider ~ ~1 ~ {HasVisualFire:0b,DeathLootTable:"apocalypse:withering_spider",Team:"withering",Health:40f,Tags:["elite","withering"],CustomName:'{"text":"Withering","color":"black"}',Attributes:[{Name:generic.max_health,Base:40},{Name:generic.armor,Base:6},{Name:generic.attack_knockback,Base:2}]}
execute in apocalypse:apocalypse as @e[type=spider,tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:wasted_desert run tp @s ~ -600 ~

## cull elite spawn entities ##
execute in apocalypse:apocalypse as @e[type=spider,tag=!apoc_rolled,scores={spawn_roll=6..10}] if entity @e[distance=..0.5,tag=elite] run kill @s
execute in apocalypse:apocalypse as @e[type=spider,tag=!apoc_rolled] run tag @s add apoc_rolled

################################ ZOGLIN #######################################

##### Rolling and tagging #####
execute in apocalypse:apocalypse as @e[type=zoglin,tag=!apoc_rolled] store result score @s spawn_roll run random value 1..10

#Blazing
execute in apocalypse:apocalypse as @e[type=zoglin,tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:wasteland run summon zoglin ~ ~1 ~ {HasVisualFire:0b,DeathLootTable:"apocalypse:withering_zoglin",Team:"withering",Health:80f,Tags:["elite","withering"],CustomName:'{"text":"Withering","color":"black"}',Attributes:[{Name:generic.max_health,Base:80},{Name:generic.armor,Base:6},{Name:generic.attack_knockback,Base:2}]}
execute in apocalypse:apocalypse as @e[type=zoglin,tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:wasteland run tp @s ~ -600 ~
execute in apocalypse:apocalypse as @e[type=zoglin,tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:wasted_desert run summon zoglin ~ ~1 ~ {HasVisualFire:0b,DeathLootTable:"apocalypse:withering_zoglin",Team:"withering",Health:80f,Tags:["elite","withering"],CustomName:'{"text":"Withering","color":"black"}',Attributes:[{Name:generic.max_health,Base:80},{Name:generic.armor,Base:6},{Name:generic.attack_knockback,Base:2}]}
execute in apocalypse:apocalypse as @e[type=zoglin,tag=!apoc_rolled,scores={spawn_roll=6..10}] at @s if biome ~ ~ ~ apocalypse:wasted_desert run tp @s ~ -600 ~

## cull elite spawn entities ##
execute in apocalypse:apocalypse as @e[type=zoglin,tag=!apoc_rolled,scores={spawn_roll=6..10}] if entity @e[distance=..0.5,tag=elite] run kill @s
execute in apocalypse:apocalypse as @e[type=zoglin,tag=!apoc_rolled] run tag @s add apoc_rolled






